#if (${Selection.package})
package ${Selection.package};

#end
#if (${data.observable})
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;

#end
public class ${data.name}
{
#if (${data.observable})
	private PropertyChangeSupport changeSupport=new PropertyChangeSupport(this);
#end
#foreach ($property in $data.properties)
	private ${property.type} ${property.name};
#end

#foreach ($property in $data.properties)
#if (${property.type}=="boolean")
	public ${property.type} is${Strings.capitalize(${property.name})}()
#else
	public ${property.type} get${Strings.capitalize(${property.name})}()
#end
	{
		return ${property.name};
	}

	public void set${Strings.capitalize(${property.name})}(${property.type} ${property.name})
	{
#if (${data.observable})
		${property.type} old${Strings.capitalize(${property.name})}=this.${property.name};
#end
		this.${property.name}=${property.name};
#if (${data.observable})
		firePropertyChange("${property.name}", old${Strings.capitalize(${property.name})}, ${property.name});
#end
	}
#end

#if (${data.observable})
	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		changeSupport.addPropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener)
	{
		changeSupport.removePropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener)
	{
		changeSupport.addPropertyChangeListener(propertyName, listener);
	}

	public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener)
	{
		changeSupport.removePropertyChangeListener(propertyName, listener);
	}

	protected void firePropertyChange(String propertyName, Object oldValue, Object newValue)
	{
		changeSupport.firePropertyChange(propertyName, oldValue, newValue);
	}
#end
}
