// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate;

import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;
import java.awt.Rectangle;
import javax.swing.JPanel;
import javax.swing.JComponent;

/**
 * A tool which scrolls the component to be visible. 
 *
 * @author Stefan Stiller
 */
class ComponentAligner implements FocusListener
{
	private final JPanel panel;
	private final JComponent component;

	ComponentAligner(JPanel panel, JComponent component)
	{
		this.panel=panel;
		this.component=component;
	}

	public void focusGained(FocusEvent e)
	{
		Rectangle bounds=component.getBounds();
		panel.scrollRectToVisible(new Rectangle(bounds.x, bounds.y-20, bounds.width, bounds.height+40));
	}

	public void focusLost(FocusEvent e)
	{
	}
}
