// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate;

import java.awt.Graphics;
import java.awt.Component;
import java.awt.Color;

import javax.swing.JTextField;
import javax.swing.UIManager;

import com.kiwisoft.utils.gui.ComponentDecorator;
import com.kiwisoft.utils.StringUtils;

/**
 * A decorator for required text components.
 *
 * @author Stefan Stiller
 */
public class RequiredDecorator implements ComponentDecorator
{
	public void prepareComponent(Graphics g, Component component)
	{
		if (component instanceof JTextField)
		{
			JTextField textField=(JTextField)component;
			if (StringUtils.isEmpty(textField.getText())) textField.setBackground(new Color(225, 255, 225));
			else textField.setBackground(UIManager.getColor("TextField.background"));
		}
	}

	public void decorateComponent(Graphics g, Component component)
	{
	}
}
