// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.formats;

import javax.swing.Icon;

import com.kiwisoft.utils.format.DefaultObjectFormat;
import com.kiwisoft.utils.StringUtils;
import com.kiwisoft.utils.gui.Icons;
import com.kiwisoft.generate.model.SystemMethod;

/**
 * Class used for formatting and rendering {@link SystemMethod} objects.
 *
 * @author Stefan Stiller
 */
public class MethodFormat extends DefaultObjectFormat
{
	public MethodFormat()
	{
		super(DEFAULT);
	}

	public boolean canFormat(Class aClass)
	{
		return aClass!=null && SystemMethod.class.isAssignableFrom(aClass);
	}

	public String format(Object value)
	{
		if (value instanceof SystemMethod)
		{
			String name=((SystemMethod)value).getName();
			if (StringUtils.isEmpty(name)) return "<Unnamed Method>";
			return name;
		}
		return super.format(value);
	}

	public Icon getIcon(Object value)
	{
		return Icons.getIcon("model.method");
	}
}
