// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.formats;

import javax.swing.Icon;

import com.kiwisoft.utils.format.DefaultObjectFormat;
import com.kiwisoft.utils.gui.Icons;
import com.kiwisoft.generate.model.Template;

/**
 * Class used for formatting and rendering {@link Template} objects.
 *
 * @author Stefan Stiller
 */
public class TemplateFormat extends DefaultObjectFormat
{
	public TemplateFormat()
	{
		super(DEFAULT);
	}

	public boolean canFormat(Class aClass)
	{
		return aClass!=null && Template.class.isAssignableFrom(aClass);
	}

	public String format(Object value)
	{
		if (value instanceof Template)
		{
			return ((Template)value).getName();
		}
		return super.format(value);
	}

	public Icon getIcon(Object value)
	{
		return Icons.getIcon("template");
	}
}
