// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.lookups;

import java.util.Collection;
import java.util.Set;
import java.util.HashSet;

import com.kiwisoft.utils.gui.lookup.ListLookup;
import com.kiwisoft.utils.StringUtils;
import com.kiwisoft.generate.model.Type;
import com.kiwisoft.generate.model.Types;
import com.kiwisoft.generate.model.Template;

/**
 * Lookup for {@link Type} objects.
 *
 * @author Stefan Stiller
 */
public class TypeLookup extends ListLookup<Type>
{
	private Template template;

	public TypeLookup()
	{
	}

	public TypeLookup(Template template)
	{
		this.template=template;
	}

	public Collection<Type> getValues(String text, Type currentValue, boolean lookup)
	{
		Set<Type> types=new HashSet<Type>();
		if (StringUtils.isEmpty(text) || lookup)
		{
			types.addAll(Types.getTypes());
			if (template!=null) types.addAll(template.getTypes());
		}
		else
		{
			for (Type type : Types.getTypes())
			{
				if (type.getName().toLowerCase().startsWith(text.toLowerCase())) types.add(type);
			}
			if (template!=null)
			{
				for (Type type : template.getTypes())
				{
					if (type.getName().toLowerCase().startsWith(text.toLowerCase())) types.add(type);
				}
			}
		}
		return types;
	}
}
