// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model;

/**
 * A type representing a flag.
 *
 * @author Stefan Stiller
 */
public class BooleanType implements Type
{
	public String getName()
	{
		return "Boolean";
	}

	public String getDisplayableName()
	{
		return getName();
	}

	public Class getTypeClass()
	{
		return Boolean.class;
	}

	public Object parse(String name)
	{
		return Boolean.valueOf(name);
	}

	public String format(Object value)
	{
		if (value instanceof Boolean) return value.toString();
		return null;
	}
}
