// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model;

/**
 * A type representing integer numbers.
 *
 * @author Stefan Stiller
 */
public class IntegerType implements Type
{
	public String getName()
	{
		return "Integer";
	}

	public String getDisplayableName()
	{
		return "Integer Number";
	}

	public Class getTypeClass()
	{
		return Integer.class;
	}

	public Object parse(String name)
	{
		try
		{
			return new Integer(name);
		}
		catch (NumberFormatException e)
		{
			return null;
		}
	}

	public String format(Object value)
	{
		if (value instanceof Integer) return value.toString();
		return null;
	}
}
