// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model;

/**
 * A type representing a string.
 *
 * @author Stefan Stiller
 */
public class StringType implements Type
{
	public String getName()
	{
		return "String";
	}

	public String getDisplayableName()
	{
		return getName();
	}

	public Class getTypeClass()
	{
		return String.class;
	}

	public Object parse(String name)
	{
		return name;
	}

	public String format(Object value)
	{
		if (value instanceof String) return value.toString();
		return null;
	}
}
