// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model;

import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.util.Collections;

/**
 * A manager for all hard coded types. 
 *
 * @author Stefan Stiller
 */
public class Types
{
	public static Map<String, Type> types=new HashMap<String, Type>();

	static
	{
		addType(new IntegerType());
		addType(new StringType());
		addType(new BooleanType());
		addType(new DecimalType());
	}

	private static void addType(Type type)
	{
		types.put(type.getName(), type);
	}

	private Types()
	{
	}

	public static Collection<Type> getTypes()
	{
		return Collections.unmodifiableCollection(types.values());
	}

	public static Type valueOf(String value)
	{
		return types.get(value);
	}
}
