// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model.ui;

import java.awt.GridBagLayout;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JPanel;

import com.kiwisoft.utils.Disposable;
import com.kiwisoft.utils.ListenerSupport;
import com.kiwisoft.utils.gui.adapters.ComponentAdapter;

/**
 * A details panel used by the {@link TemplateDialog}.
 *
 * @author Stefan Stiller
 */
public class DetailsPanel<T> extends JPanel implements Disposable
{
	private ListenerSupport listenerSupport=new ListenerSupport();
	private List<ComponentAdapter> adapters=new ArrayList<ComponentAdapter>();
	private T object;

	public DetailsPanel(T object)
	{
		super(new GridBagLayout());
		this.object=object;
	}

	public boolean stopEditing()
	{
		for (ComponentAdapter adapter : adapters)
		{
			if (!adapter.stopEditing()) return false;
		}
		return true;
	}

	public void dispose()
	{
		listenerSupport.dispose();
	}

	public void addAdapter(ComponentAdapter adapter)
	{
		adapters.add(adapter);
	}

	public ListenerSupport getListenerSupport()
	{
		return listenerSupport;
	}

	public T getObject()
	{
		return object;
	}

	public String getHelpTopic()
	{
		return null;
	}
}
