// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.tree;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import com.kiwisoft.generate.model.UserParameter;
import com.kiwisoft.utils.gui.tree.GenericTreeNode;

/**
 * A tree node representing a user defined parameter. 
 *
 * @author Stefan Stiller
 */
public class ParameterNode extends GenericTreeNode<UserParameter> implements PropertyChangeListener
{
	public ParameterNode(UserParameter parameter)
	{
		super(parameter);
		parameter.addPropertyChangeListener(this);
	}

	public boolean isLeaf()
	{
		return true;
	}

	public void propertyChange(PropertyChangeEvent evt)
	{
		if ("name".equals(evt.getPropertyName())) fireNodeChanged();
	}

	public void dispose()
	{
		getUserObject().removePropertyChangeListener(this);
		super.dispose();
	}
}
