// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.tree;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

import com.kiwisoft.generate.model.TemplateFile;
import com.kiwisoft.utils.gui.tree.GenericTreeNode;

/**
 * A tree node representing a single template file. 
 *
 * @author Stefan Stiller
 */
public class TemplateFileNode extends GenericTreeNode<TemplateFile> implements PropertyChangeListener
{
	public TemplateFileNode(TemplateFile file)
	{
		super(file);
		file.addPropertyChangeListener(this);
	}

	public boolean isLeaf()
	{
		return true;
	}

	public void propertyChange(PropertyChangeEvent evt)
	{
		if ("name".equals(evt.getPropertyName())) fireNodeChanged();
	}

	public void dispose()
	{
		getUserObject().removePropertyChangeListener(this);
		super.dispose();
	}
}
