// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.tree;

import java.util.Vector;

import com.kiwisoft.utils.gui.tree.GenericTreeNode;
import com.kiwisoft.generate.model.Template;

/**
 * A tree node used as parent for all template elements. 
 *
 * @author Stefan Stiller
 */
public class TemplateNode extends GenericTreeNode<Template>
{
	public TemplateNode(Template template)
	{
		super(template);
	}

	public Vector<GenericTreeNode> loadChildren()
	{
		Vector<GenericTreeNode> children=super.loadChildren();
		children.add(new UserParametersNode(getUserObject()));
		children.add(new UserTypesNode(getUserObject()));
		children.add(new FilesNode(getUserObject()));
		children.add(new SystemParametersNode());
		children.add(new SystemMethodsNode());
		return children;
	}
}
