// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.4 $, $Date: 2006/03/24 18:02:05 $
 */
public class SetMap
{
	private Map map;

	public SetMap()
	{
		map=new HashMap();
	}

	public synchronized void add(Object key, Object value)
	{
		Set set=(Set)map.get(key);
		if (set==null)
		{
			set=new HashSet();
			map.put(key,set);
		}
		set.add(value);
	}

	public synchronized Set remove(Object key)
	{
		Set set=(Set)map.remove(key);
		if (set!=null) return set;
		else return Collections.EMPTY_SET;
	}

	public synchronized void remove(Object key, Object value)
	{
		Set set=(Set)map.get(key);
		if (set!=null)
		{
			set.remove(value);
			if (set.isEmpty()) map.remove(key);
		}
	}

	public Set get(Object key)
	{
		Set set=(Set)map.get(key);
		if (set!=null) return Collections.unmodifiableSet(set);
		else return Collections.EMPTY_SET;
	}

	public boolean containsKey(Object key)
	{
		return map.containsKey(key);
	}

    public boolean contains(Object key, Object value)
    {
        Set set=(Set)map.get(key);
        if (set!=null) return set.contains(value);
        else return false;
    }

	public boolean isEmpty()
	{
		return map.isEmpty();
	}

	public Set keySet()
	{
		return map.keySet();
	}
}
