// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.format;

/**
 * Interface class for displaying objects in UI two state fields like checkboxes.
 *
 * @author Stefan Stiller
 * @version $Revision: 1.2 $, $Date: 2006/03/24 18:05:38 $
 */
public interface BooleanFormat extends ObjectFormat
{
	/**
	 * Returns the <code>Boolean</code> representing the specified value.
	 *
	 * @param value The object which should be formated.
	 * @return The Boolean representing the specified object.
	 * @see #canFormat(Class)
	 */
	Boolean format(Object value);

	/**
	 * Returns the <code>Object</code> created from the specified <code>Boolean</code>.
	 * The method may throw an <code>RuntimeException</code> if the <code>Boolean</code> is invalid.
	 *
	 * @param value	   The <code>Boolean</code> which should be parsed.
	 * @param targetClass The <code>Class</code> the return value should have. Can be ignored if
	 *                    the format handles only one class.
	 * @return The <code>Object</code> created from the <code>Boolean</code>.
	 * @see #canParse(Class)
	 */
	Object parse(Boolean value, Class targetClass);
}
