// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.format;

import com.kiwisoft.utils.StringUtils;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 18:05:38 $
 */
public class ByteArrayFormat extends DefaultObjectFormat
{
	public ByteArrayFormat(String name)
	{
		super(name);
	}

	public boolean canFormat(Class aClass)
	{
		return byte[].class==aClass;
	}

	public String format(Object value)
	{
		if (value instanceof byte[])
		{
			byte[] bytes=(byte[])value;
			StringBuffer buffer=new StringBuffer(bytes.length*3);
			for (int i=0; i<bytes.length; i++)
			{
				if (i>0) buffer.append(" ");
				buffer.append(StringUtils.toByteString(bytes[i]));
			}
			return buffer.toString();
		}
		return super.format(value);
	}
}
