// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.format;

import java.math.BigDecimal;
import java.math.BigInteger;
import javax.swing.SwingConstants;

import com.kiwisoft.utils.StringUtils;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 18:05:39 $
 */
public class DefaultNumberFormat extends DefaultObjectFormat
{
	public DefaultNumberFormat(String name)
	{
		super(name);
	}

	public boolean canFormat(Class aClass)
	{
		return aClass!=null && Number.class.isAssignableFrom(aClass);
	}

	public boolean canParse(Class aClass)
	{
		return aClass!=null && Number.class.isAssignableFrom(aClass);
	}

	public Object parse(String value, Class targetClass)
	{
		if (StringUtils.isEmpty(value)) return null;
		value=value.trim();
		Number number=new BigDecimal(value);
		if (targetClass.isInstance(number)) return number;
		if (targetClass==Double.class) return number.doubleValue();
		if (targetClass==Float.class) return number.floatValue();
		if (targetClass==Long.class) return number.longValue();
		if (targetClass==Integer.class) return number.intValue();
		if (targetClass==Short.class) return number.shortValue();
		if (targetClass==Byte.class) return number.byteValue();
		if (targetClass==BigDecimal.class) return number;
		if (targetClass==BigInteger.class) return ((BigDecimal)number).toBigInteger();
		return number;
	}

	public int getHorizontalAlignment(Object value)
	{
		return SwingConstants.TRAILING;
	}
}
