// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.format;

import java.text.NumberFormat;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 18:33:38 $
 */
public class MoneyFormat extends DefaultNumberFormat
{
	private NumberFormat currencyInstance;

	public MoneyFormat(String name)
	{
		super(name);
		currencyInstance=NumberFormat.getCurrencyInstance();
	}

	public String format(Object value)
	{
		if (value instanceof Number) return currencyInstance.format(value);
		return super.format(value);
	}

	public boolean canParse(Class aClass)
	{
		return false;
	}

	public Object parse(String value, Class targetClass)
	{
		throw new UnsupportedOperationException();
	}
}
