// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.format;

import java.util.Date;
import javax.swing.SwingConstants;

import com.kiwisoft.utils.StringUtils;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 18:33:39 $
 */
public class TimeMillisFormat extends DefaultObjectFormat
{
    private String name;

	public TimeMillisFormat(String name)
	{
		super("Default");
		this.name=name;
	}

	public String getName()
	{
		return name;
	}

	public boolean canFormat(Class aClass)
	{
		return aClass!=null && Date.class.isAssignableFrom(aClass);
	}

	public String format(Object value)
	{
		if (value instanceof Date) return String.valueOf(((Date)value).getTime());
		return super.format(value);
	}

	public boolean canParse(Class aClass)
	{
		return aClass!=null && Date.class.isAssignableFrom(aClass);
	}

	public Object parse(String value, Class targetClass)
	{
		if (StringUtils.isEmpty(value)) return null;
		return new Date(Long.parseLong(value));
	}

	public int getHorizontalAlignment(Object value)
	{
		return SwingConstants.TRAILING;
	}
}
