// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui;

import java.util.List;
import java.util.Arrays;
import java.awt.Graphics;
import javax.swing.JFormattedTextField;

import com.kiwisoft.utils.gui.table.TableRendererFactory;

/**
 * A text field which allows to attach {@link com.kiwisoft.utils.gui.ComponentDecorator}'s to it.
 *
 * @author Stefan Stiller
 */
public class DecoratedFormattedTextField extends JFormattedTextField implements DecoratedComponent
{
	private List<ComponentDecorator> decorators;

	public DecoratedFormattedTextField(ComponentDecorator... decorators)
	{
		this.decorators=Arrays.asList(decorators);
	}

	public DecoratedFormattedTextField()
	{
	}

	public void setDecorators(ComponentDecorator... decorator)
	{
		this.decorators=Arrays.asList(decorator);
	}

	protected void paintComponent(Graphics g)
	{
		TableRendererFactory.prepareComponent(g, this, decorators);
		super.paintComponent(g);
		TableRendererFactory.decorateComponent(g, this, decorators);
	}
}
