// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui;

import java.util.List;
import java.util.Arrays;
import java.awt.Graphics;
import javax.swing.JTextField;

import com.kiwisoft.utils.gui.table.TableRendererFactory;

/**
 * A text field which allows to attach {@link ComponentDecorator}'s to it.  
 *
 * @author Stefan Stiller
 */
public class DecoratedTextField extends JTextField implements DecoratedComponent
{
	private List<ComponentDecorator> decorators;

	public DecoratedTextField(int columns, ComponentDecorator... decorators)
	{
		super(columns);
		this.decorators=Arrays.asList(decorators);
	}

	public DecoratedTextField(int columns)
	{
		super(columns);
	}

	public void setDecorators(ComponentDecorator... decorator)
	{
		this.decorators=Arrays.asList(decorator);
	}

	protected void paintComponent(Graphics g)
	{
		TableRendererFactory.prepareComponent(g, this, decorators);
		super.paintComponent(g);
		TableRendererFactory.decorateComponent(g, this, decorators);
	}
}
