// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.adapters;

import java.util.Set;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.lang.reflect.InvocationTargetException;

import javax.swing.event.TableModelListener;
import javax.swing.event.TableModelEvent;
import javax.swing.table.TableModel;

import org.apache.commons.beanutils.PropertyUtils;

import com.kiwisoft.utils.ObservableBean;
import com.kiwisoft.utils.gui.table.SetTable;
import com.kiwisoft.utils.gui.table.SetTableModel;

/**
 * Created by IntelliJ IDEA.
 * User: Stefan1
 * Date: 05.11.2006
 * Time: 12:59:50
 * To change this template use File | Settings | File Templates.
 */
public class SetAdapter implements ComponentAdapter, TableModelListener, PropertyChangeListener
{
	private SetTable table;
	private ObservableBean bean;
	private String propertyName;

	public SetAdapter(SetTable table)
	{
		this.table=table;
	}

	public void bind(ObservableBean bean, String propertyName) throws Exception
	{
		this.bean=bean;
		this.propertyName=propertyName;
		boolean readable=PropertyUtils.isReadable(bean, propertyName);
		boolean writeable=readable && PropertyUtils.isWriteable(bean, propertyName);
		SetTableModel model=getModel();
		model.setEditable(writeable);
		table.setEnabled(readable);
		if (bean!=null)
		{
			if (readable)
			{
				Set values=(Set)PropertyUtils.getProperty(bean, propertyName);
				model.setSet(values);
				bean.addPropertyChangeListener(propertyName, this);
				if (writeable) model.addTableModelListener(this);
			}
		}
	}

	public void unbind()
	{
		if (bean!=null)
		{
			bean.removePropertyChangeListener(propertyName, this);
			getModel().removeTableModelListener(this);
		}
	}

	public boolean stopEditing()
	{
		if (table.isEditing()) return table.getCellEditor().stopCellEditing();
		return true;
	}

	public void tableChanged(TableModelEvent e)
	{
		try
		{
			PropertyUtils.setProperty(bean, propertyName, getModel().getSet());
		}
		catch (Exception e1)
		{
			throw new RuntimeException(e1);
		}
	}

	private SetTableModel getModel()
	{
		return (SetTableModel)table.getModel();
	}

	public void propertyChange(PropertyChangeEvent evt)
	{
		try
		{
			Set values=(Set)PropertyUtils.getProperty(bean, propertyName);
			getModel().setSet(values);
		}
		catch (Exception e)
		{
			throw new RuntimeException();
		}
	}
}
