// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.lookup;

import javax.swing.Icon;
import javax.swing.JTextField;

import org.jetbrains.annotations.NotNull;

/**
 * Lookup which uopens a dialog to support editing of text fields.
 *
 * @author Stefan Stiller
 */
public interface DialogLookup
{
	/**
	 * Called by the lookup handler to request the opening of the lookup dialog.
	 *
	 * @param field The field the lookup is bound to.
	 */
	void open(@NotNull JTextField field);

	/**
	 * @return The icon used for the lookup button.
	 */
	Icon getIcon();
}
