// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.lookup;

import java.util.Collection;
import java.util.Set;
import java.util.Collections;
import java.util.HashSet;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.4 $, $Date: 2006/03/24 18:04:42 $
 */
public class TextLookup extends ListLookup<String>
{
	private Set<String> values;
	private boolean restricted;

	public TextLookup(Set<String> values, boolean restricted)
	{
		this.values=values;
		this.restricted=restricted;
	}

	public Collection<String> getValues(String text, String currentValue, boolean lookup)
	{
		if (lookup) return values;
		if (restricted)
		{
			Set<String> values=new HashSet<String>();
			for (String value : this.values)
			{
				if (value.toLowerCase().startsWith(text.toLowerCase())) values.add(value);
			}
			return values;
		}
		if (text!=null) return Collections.singleton(text);
		return Collections.emptySet();
	}
}
