// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.xml;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 17:48:08 $
 */
public class XMLContext
{
	private XMLHandler handler;
	private String fileName;
	private Map<String, Object> attributes=new HashMap<String, Object>();

	public XMLContext(XMLHandler handler)
	{
		this.handler=handler;
	}

	public XMLHandler getHandler()
	{
		return handler;
	}

	public String getFileName()
	{
		return fileName;
	}

	public void setFileName(String fileName)
	{
		this.fileName=fileName;
	}

	public void setAttribute(String name, Object value)
	{
		attributes.put(name, value);
	}

	public void removeAttribute(String name)
	{
		attributes.remove(name);
	}

	public Object getAttribute(String name)
	{
		return attributes.get(name);
	}
}
